/*
 * @Author: your name
 * @Date: 2021-06-28 11:51:14
 * @LastEditTime: 2021-06-28 14:29:33
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath: \ewebengine\tools\evm_monitor\src\router\index.js
 */
import Vue from "vue";
import Router from "vue-router";

Vue.use(Router);

/* Layout */
import Layout from "@/layout";

/**
 * Note: sub-menu only appear when route children.length >= 1
 * Detail see: https://panjiachen.github.io/vue-element-admin-site/guide/essentials/router-and-nav.html
 *
 * hidden: true                   if set true, item will not show in the sidebar(default is false)
 * alwaysShow: true               if set true, will always show the root menu
 *                                if not set alwaysShow, when item has more than one children route,
 *                                it will becomes nested mode, otherwise not show the root menu
 * redirect: noRedirect           if set noRedirect will no redirect in the breadcrumb
 * name:'router-name'             the name is used by <keep-alive> (must set!!!)
 * meta : {
    roles: ['admin','editor']    control the page roles (you can set multiple roles)
    title: 'title'               the name show in sidebar and breadcrumb (recommend set)
    icon: 'svg-name'             the icon show in the sidebar
    breadcrumb: false            if set false, the item will hidden in breadcrumb(default is true)
    activeMenu: '/example/list'  if set path, the sidebar will highlight the path you set
  }
 */


/**
 * constantRoutes
 * a base page that does not have permission requirements
 * all roles can be accessed
 */
export const constantRoutes = [
    {
        path: '/',
        redirect: '/home'
    },
    {
        path: '/home',
        redirect: '/home/index',
        component: Layout,
        children: [{
            path: 'index',
            name: 'AppIndex',
            component: () => import('@/views/system/index'),
            meta: { title: '监控', icon: 'home' }
        }]
    },
    {
        path: '/404',
        redirect: '/404/index',
        component: Layout,
        children: [{
            path: 'index',
            name: 'Page404',
            component: () => import('@/views/error-pages/404'),
            meta: { title: '404', icon: 'home' }
        }]
    },
    {
        path: '/403',
        redirect: '/403/index',
        component: Layout,
        children: [{
            path: 'index',
            name: 'Page403',
            component: () => import('@/views/error-pages/403'),
            meta: { title: '403', icon: 'home' }
        }]
    },
    { path: '*', redirect: '/404', hidden: true }
];

// 404 page must be placed at the end !!!
export const notFound = { path: '*', redirect: '/404', hidden: true }

const createRouter = () =>
    new Router({
        // mode: 'history', // require service support, 后台部署在/static 目录
        // base: "/static", // 应用的基础路径: 默认为'/',修改为'/static'
        scrollBehavior: () => ({ y: 0 }),
        routes: constantRoutes,
    });

const router = createRouter();

// Detail see: https://github.com/vuejs/vue-router/issues/1234#issuecomment-357941465
export function resetRouter() {
    const newRouter = createRouter();
    router.matcher = newRouter.matcher; // reset router
}

export default router;
